package net.nicoulaj.maven.plugins.checksum.mojo;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on checksum-maven-plugin.<br/> Call <pre>  mvn checksum:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Sun Apr 15 13:51:49 CEST 2012
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.9)
 * @goal help
 * @requiresProject false
 * @threadSafe
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "net.ju-n.maven.plugins:checksum-maven-plugin:1.0.1", 0 );
        append( sb, "", 0 );

        append( sb, "checksum-maven-plugin", 0 );
        append( sb, "Compute project artifacts/dependencies/files checksum digests and output them to individual or summary files.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 5 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "artifacts".equals( goal ) )
        {
            append( sb, "checksum:artifacts", 0 );
            append( sb, "Compute project artifacts checksum digests and store them in individual files and/or a summary file.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "algorithms", 2 );
                append( sb, "The list of checksum algorithms used.\nDefault value is MD5 and SHA-1.\nAllowed values are CRC32, MD2, MD4, MD5, SHA-1, SHA-224, SHA-256, SHA-384, SHA-512, RIPEMD128, RIPEMD160, RIPEMD256, RIPEMD320, GOST3411 and Tiger.\n\nUse the following syntax:\n\n<algorithms>\n\u00a0\u00a0<algorithm>MD5<algorithm>\n\u00a0\u00a0<algorithm>SHA-1<algorithm>\n</algorithms>\n\n\n", 3 );
                append( sb, "", 0 );

                append( sb, "csvSummary (Default: false)", 2 );
                append( sb, "Indicates whether the build will store checksums to a single CSV summary file.", 3 );
                append( sb, "", 0 );

                append( sb, "csvSummaryFile (Default: artifacts-checksums.csv)", 2 );
                append( sb, "The name of the summary file created if the option is activated.", 3 );
                append( sb, "", 0 );

                append( sb, "encoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "Encoding to use for generated files.", 3 );
                append( sb, "Expression: ${encoding}", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: true)", 2 );
                append( sb, "Indicates whether the build will fail if there are errors.", 3 );
                append( sb, "", 0 );

                append( sb, "individualFiles (Default: true)", 2 );
                append( sb, "Indicates whether the build will store checksums in separate files (one file per algorithm per artifact).", 3 );
                append( sb, "", 0 );

                append( sb, "individualFilesOutputDirectory", 2 );
                append( sb, "The directory where output files will be stored. Leave unset to have each file next to the source file.", 3 );
                append( sb, "", 0 );

                append( sb, "quiet (Default: false)", 2 );
                append( sb, "Indicates whether the build will print checksums in the build log.", 3 );
                append( sb, "", 0 );

                append( sb, "xmlSummary (Default: false)", 2 );
                append( sb, "Indicates whether the build will store checksums to a single XML summary file.", 3 );
                append( sb, "", 0 );

                append( sb, "xmlSummaryFile (Default: artifacts-checksums.xml)", 2 );
                append( sb, "The name of the summary file created if the option is activated.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "dependencies".equals( goal ) )
        {
            append( sb, "checksum:dependencies", 0 );
            append( sb, "Compute project dependencies checksum digests and store them in a summary file.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "algorithms", 2 );
                append( sb, "The list of checksum algorithms used.\nDefault value is MD5 and SHA-1.\nAllowed values are CRC32, MD2, MD4, MD5, SHA-1, SHA-224, SHA-256, SHA-384, SHA-512, RIPEMD128, RIPEMD160, RIPEMD256, RIPEMD320, GOST3411 and Tiger.\n\nUse the following syntax:\n\n<algorithms>\n\u00a0\u00a0<algorithm>MD5<algorithm>\n\u00a0\u00a0<algorithm>SHA-1<algorithm>\n</algorithms>\n\n\n", 3 );
                append( sb, "", 0 );

                append( sb, "csvSummary (Default: true)", 2 );
                append( sb, "Indicates whether the build will store checksums to a single CSV summary file.", 3 );
                append( sb, "", 0 );

                append( sb, "csvSummaryFile (Default: dependencies-checksums.csv)", 2 );
                append( sb, "The name of the summary file created if the option is activated.", 3 );
                append( sb, "", 0 );

                append( sb, "encoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "Encoding to use for generated files.", 3 );
                append( sb, "Expression: ${encoding}", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: true)", 2 );
                append( sb, "Indicates whether the build will fail if there are errors.", 3 );
                append( sb, "", 0 );

                append( sb, "individualFiles (Default: false)", 2 );
                append( sb, "Indicates whether the build will store checksums in separate files (one file per algorithm per artifact).", 3 );
                append( sb, "", 0 );

                append( sb, "individualFilesOutputDirectory (Default: ${project.build.directory})", 2 );
                append( sb, "The directory where output files will be stored. Leave unset to have each file next to the source file.", 3 );
                append( sb, "", 0 );

                append( sb, "quiet (Default: false)", 2 );
                append( sb, "Indicates whether the build will print checksums in the build log.", 3 );
                append( sb, "", 0 );

                append( sb, "scopes", 2 );
                append( sb, "The dependency scopes to include.\nAllowed values are compile, test, runtime, provided and system.\nAll scopes are included by default.\n\nUse the following syntax:\n\n<scopes>\n\u00a0\u00a0<scope>compile<scope>\n\u00a0\u00a0<scope>runtime<scope>\n</scopes>\n\n\n", 3 );
                append( sb, "", 0 );

                append( sb, "types", 2 );
                append( sb, "The dependency types to include.\nAll types are included by default.\n\nUse the following syntax:\n\n<types>\n\u00a0\u00a0<type>jar<type>\n\u00a0\u00a0<type>zip<type>\n</types>\n\n\n", 3 );
                append( sb, "", 0 );

                append( sb, "xmlSummary (Default: false)", 2 );
                append( sb, "Indicates whether the build will store checksums to a single XML summary file.", 3 );
                append( sb, "", 0 );

                append( sb, "xmlSummaryFile (Default: dependencies-checksums.xml)", 2 );
                append( sb, "The name of the summary file created if the option is activated.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "file".equals( goal ) )
        {
            append( sb, "checksum:file", 0 );
            append( sb, "Compute specified file checksum digest for all supported checksum algorithms.\nThis goal is a facility for invoking checksum-maven-plugin through the command line.\n\nHere is an example of use:\n\nmvn\u00a0checksum:file\u00a0-Dfile=some-file.zip\n\n\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "file", 2 );
                append( sb, "The file to process.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${file}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "files".equals( goal ) )
        {
            append( sb, "checksum:files", 0 );
            append( sb, "Compute specified files checksum digests and store them in individual files and/or a summary file.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "algorithms", 2 );
                append( sb, "The list of checksum algorithms used.\nDefault value is MD5 and SHA-1.\nAllowed values are CRC32, MD2, MD4, MD5, SHA-1, SHA-224, SHA-256, SHA-384, SHA-512, RIPEMD128, RIPEMD160, RIPEMD256, RIPEMD320, GOST3411 and Tiger.\n\nUse the following syntax:\n\n<algorithms>\n\u00a0\u00a0<algorithm>MD5<algorithm>\n\u00a0\u00a0<algorithm>SHA-1<algorithm>\n</algorithms>\n\n\n", 3 );
                append( sb, "", 0 );

                append( sb, "csvSummary (Default: true)", 2 );
                append( sb, "Indicates whether the build will store checksums to a single CSV summary file.", 3 );
                append( sb, "", 0 );

                append( sb, "csvSummaryFile (Default: files-checksums.csv)", 2 );
                append( sb, "The name of the summary file created if the option is activated.", 3 );
                append( sb, "", 0 );

                append( sb, "encoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "Encoding to use for generated files.", 3 );
                append( sb, "Expression: ${encoding}", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: true)", 2 );
                append( sb, "Indicates whether the build will fail if there are errors.", 3 );
                append( sb, "", 0 );

                append( sb, "files", 2 );
                append( sb, "The list of files to process.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "individualFiles (Default: true)", 2 );
                append( sb, "Indicates whether the build will store checksums in separate files (one file per algorithm per artifact).", 3 );
                append( sb, "", 0 );

                append( sb, "individualFilesOutputDirectory", 2 );
                append( sb, "The directory where output files will be stored. Leave unset to have each file next to the source file.", 3 );
                append( sb, "", 0 );

                append( sb, "quiet (Default: false)", 2 );
                append( sb, "Indicates whether the build will print checksums in the build log.", 3 );
                append( sb, "", 0 );

                append( sb, "xmlSummary (Default: false)", 2 );
                append( sb, "Indicates whether the build will store checksums to a single XML summary file.", 3 );
                append( sb, "", 0 );

                append( sb, "xmlSummaryFile (Default: files-checksums.xml)", 2 );
                append( sb, "The name of the summary file created if the option is activated.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "checksum:help", 0 );
            append( sb, "Display help information on checksum-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0checksum:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "Expression: ${detail}", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "Expression: ${goal}", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "Expression: ${indentSize}", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "Expression: ${lineLength}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
